//---------------------------------------------------------------------------
#include <fstream>
#include <vcl.h>
#pragma hdrstop

#include "dlg_vztahy.h" 
#include "dlg_pridat.h"
#include "dlg_ukaz.h"
#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
using namespace std;

TForm1 *Form1;

//nat osobu z formtu XML
bool nactiosobu(ifstream &fi, tosoba *uk) {
   char bafr[100], val[100];
   while(fi.good())
   {
      while(fi.peek()!='<' && fi.good()) fi.ignore();
      fi.ignore();
      fi.getline(bafr, sizeof(bafr), '>');
      //if(!strcmp(bafr, "/rodokmen")) return false;
      if(!strcmp(bafr, "osoba"))
      {
         do
         {
            while(fi.peek()!='<') fi.ignore();
            fi.ignore();
            fi.getline(bafr, sizeof(bafr), '>');
            if(strchr(bafr, '/') && strchr(bafr, '/')!=bafr)
               { *strchr(bafr, '/') = 0; *val = 0; }
            else fi.getline(val, sizeof(val), '<');

            if(!strcmp(bafr, "id")) strcpy(uk->id, val);
            if(!strcmp(bafr, "jmeno")) strcpy(uk->jmeno, val);
            if(!strcmp(bafr, "prijmeni")) strcpy(uk->prijmeni, val);
            if(!strcmp(bafr, "pohlavi")) uk->pohlavi = (val[0]=='M');
            if(!strcmp(bafr, "narozeni")) uk->narozeni = String(val).ToIntDef(0);
            if(!strcmp(bafr, "umrti")) uk->umrti = String(val).ToIntDef(0);
            if(!strcmp(bafr, "matka")) strcpy(uk->idmatka, val);
            if(!strcmp(bafr, "otec")) strcpy(uk->idotec, val);
          }while(strcmp(bafr, "/osoba"));
          fi.seekg(fi.tellg()-1);
          return 1;
      }
   }
   return 0;
}

//ukld osobu do XML
void ulozosobu(ofstream &fo, tosoba *uk) {
   fo << "<osoba>\n";
   fo << "<id>" << uk->id << "</id>\n";

   if(!strlen(uk->jmeno)) fo << "<jmeno/>\n";
   else fo << "<jmeno>" << uk->jmeno << "</jmeno>\n";
   if(!strlen(uk->prijmeni)) fo << "<prijmeni/>\n";
   else fo << "<prijmeni>" << uk->prijmeni << "</prijmeni>\n";
   fo << "<pohlavi>" << (uk->pohlavi ? "M" : "Z") << "</pohlavi>\n";
   if(!uk->narozeni) fo << "<narozeni/>\n";
   else fo << "<narozeni>" << uk->narozeni << "</narozeni>\n";
   if(!uk->umrti) fo << "<umrti/>\n";
   else fo << "<umrti>" << uk->umrti << "</umrti>\n";
   if(!strlen(uk->idmatka)) fo << "<matka/>\n";
   else fo << "<matka>" << uk->idmatka << "</matka>\n";
   if(!strlen(uk->idotec)) fo << "<otec/>\n";
   else fo << "<otec>" << uk->idotec << "</otec>\n";

   fo << "</osoba>\n";
}
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
   : TForm(Owner), osob(0), data(0)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Konec1Click(TObject *Sender)
{
   Close();
}
//---------------------------------------------------------------------------
//pid 1 osobu
void __fastcall TForm1::Pidatosobu1Click(TObject *Sender)
{
   if(dlgPridat->ShowModal() == mrOk) {
      tosoba *dat = new tosoba[osob+1];
      memcpy(dat+1, data, osob*sizeof(tosoba));
      osob++;
      delete [] data; data = dat;

      strcpy(data->id, dlgPridat->Edit1->Text.c_str());
      strcpy(data->jmeno, dlgPridat->Edit2->Text.c_str());
      strcpy(data->prijmeni, dlgPridat->Edit3->Text.c_str());
      data->narozeni = dlgPridat->Edit4->Text.ToIntDef(0);
      data->umrti = dlgPridat->Edit5->Text.ToIntDef(0);
      strcpy(data->idmatka, dlgPridat->Edit7->Text.c_str());
      strcpy(data->idotec, dlgPridat->Edit6->Text.c_str());
      data->pohlavi = dlgPridat->ComboBox1->ItemIndex;
      StatusBar1->SimpleText = "Osob: " + String(osob);
   }
}
//---------------------------------------------------------------------------
//nate (a nahrad star) rodokmen
void __fastcall TForm1::Nastrodokmen1Click(TObject *Sender)
{
   if(OpenDialog1->Execute()) {
      ifstream fi(OpenDialog1->FileName.c_str());
      tosoba *dt = new tosoba[100000];
      tosoba *uk = dt;

      osob = 0;
      while(fi.good())
      {
         if(!nactiosobu(fi, uk)) break;
         osob++;
         uk++;
      }
      delete [] data;
      data = new tosoba[osob];
      memcpy(data, dt, osob*sizeof(tosoba));
      delete [] dt;
      StatusBar1->SimpleText = "Osob: " + String(osob);
      Application->MessageBox("Nateno", "", MB_OK | MB_ICONINFORMATION);
   }
}
//---------------------------------------------------------------------------
//ulo cel rodokmen (databzi)
void __fastcall TForm1::Uloitrodokmen1Click(TObject *Sender)
{
   if(SaveDialog1->Execute()) {
      ofstream fo(SaveDialog1->FileName.c_str(), ios_base::trunc);
      fo << "<rodokmen>\n";
      for(int i = 0; i < osob; i++)
         ulozosobu(fo, data+i);
      fo << "</rodokmen>\n";

      Application->MessageBox("Uloeno", "", MB_OK | MB_ICONINFORMATION);
   }
}
//---------------------------------------------------------------------------
//prochz pes vechny osoby
void __fastcall TForm1::Zmnitosobu1Click(TObject *Sender)
{
   if(!osob) Application->MessageBox("Nen co prochzet", "Chyba", MB_OK | MB_ICONHAND);
   else {
      Zacatek();
      dlgUkaz->ShowModal();
   }
}
//---------------------------------------------------------------------------
//aktualizuje komponnety na dlgUkaz a dlgVztahy
void TForm1::PosliData() {
    dlgUkaz->Edit1->Text = data[pozice].id;
    dlgUkaz->Edit2->Text = data[pozice].jmeno;
    dlgUkaz->Edit3->Text = data[pozice].prijmeni;
    dlgUkaz->Edit4->Text = data[pozice].narozeni;
    dlgUkaz->Edit5->Text = data[pozice].umrti;
    dlgUkaz->Edit6->Text = data[pozice].idmatka;
    dlgUkaz->Edit7->Text = data[pozice].idotec;
    dlgUkaz->ComboBox1->ItemIndex = data[pozice].pohlavi;

    dlgVztahy->Edit1->Text = data[pozice].id;
    dlgVztahy->Edit2->Text = data[pozice].jmeno;
    dlgVztahy->Edit3->Text = data[pozice].prijmeni;
    dlgVztahy->Edit4->Text = data[pozice].narozeni;
    dlgVztahy->Edit5->Text = data[pozice].umrti;
    dlgVztahy->ComboBox1->ItemIndex = data[pozice].pohlavi;
}

//pro navigaci v dlgUkaz
void TForm1::Zacatek() {
   pozice = 0;
   PosliData();
}

void TForm1::Konec() {
   pozice = osob-1;
   PosliData();
}
void TForm1::Predchozi() {
   if(--pozice < 0) pozice = 0;
   PosliData();
}
void TForm1::Dalsi() {
   if(++pozice >= osob) pozice = osob-1;
   PosliData();
}

//existuje tu u osoba s tmto id?
bool TForm1::Existuje(const char *id) {
   for(int i = 0; i < osob; i++)
      if(!strcmp(data[i].id, id)) return true;
   return false;
}

//sluovn rodokmen do 1 (a pak se me uloit)
void __fastcall TForm1::Pidatrodokmen1Click(TObject *Sender)
{
   if(OpenDialog1->Execute()) {
      ifstream fi(OpenDialog1->FileName.c_str());
      tosoba *dt = new tosoba[100000];
      memcpy(dt, data, osob*sizeof(tosoba));
      delete [] data; data = dt;
      tosoba *uk = dt+osob;

      while(fi.good())
      {
         if(!nactiosobu(fi, uk)) break;
         osob++;
         uk++;
      }
      StatusBar1->SimpleText = "Osob: " + String(osob);
      Application->MessageBox("Nateno", "", MB_OK | MB_ICONINFORMATION);
   }
}
//---------------------------------------------------------------------------
//zobraz pbuzensk vztahy ke zvolen osob (kter znm)
void __fastcall TForm1::Pbuzenskvztahy1Click(TObject *Sender)
{
   if(!osob) Application->MessageBox("Nen co prochzet", "Chyba", MB_OK | MB_ICONHAND);
   else {
      Zacatek();
      dlgVztahy->ShowModal();
   }
}
//---------------------------------------------------------------------------
//najde vechny pbuzn a nacpe je do dlgVztahy->Grid
void TForm1::Vztahy(int kod) {
   dlgVztahy->Grid1->RowCount = 1;
   int pocet = 0;
   switch(kod) {
      //manel/manelka
      case 0:
         for(int i = 0; i < osob; i++) {
            if(!strcmp(data[i].idotec, data[pozice].id))
               PridejID(data[i].idmatka, pocet);
            else if(!strcmp(data[i].idmatka, data[pozice].id))
               PridejID(data[i].idotec, pocet);
         }
         break;
      //dti
      case 1:
         for(int i = 0; i < osob; i++)
            if(!strcmp(data[i].idotec, data[pozice].id) || !strcmp(data[i].idmatka, data[pozice].id))
               PridejOsobu(i, pocet);
         break;
      //rodie
      case 2:
         for(int i = 0; i < osob; i++)
            if(!strcmp(data[i].id, data[pozice].idotec) || !strcmp(data[i].id, data[pozice].idmatka))
               PridejOsobu(i, pocet);
         break;
      //prarodie
      case 3:
         for(int i = 0; i < osob; i++)
            if(!strcmp(data[i].id, data[pozice].idotec) || !strcmp(data[i].id, data[pozice].idmatka)) {
               PridejID(data[i].idotec, pocet);
               PridejID(data[i].idmatka, pocet);
            }
         break;
      //vnouata
      case 4:
         for(int i = 0; i < osob; i++) {
            int otec = Index(data[i].idotec);
            if(!strcmp(data[otec].idotec, data[pozice].id) || !strcmp(data[otec].idmatka, data[pozice].id))
               PridejOsobu(i, pocet);
            int matka = Index(data[i].idmatka);
            if(!strcmp(data[matka].idotec, data[pozice].id) || !strcmp(data[matka].idmatka, data[pozice].id))
               PridejOsobu(i, pocet);
         }
         break;
      //bratranci/sestenice
      case 5: {
         int otec = Index(data[pozice].idotec);
         for(int i = 0; i < osob; i++)
            if((strlen(data[otec].idotec) && !strcmp(data[otec].idotec, data[i].idotec)) || (strlen(data[otec].idmatka) && !strcmp(data[otec].idmatka, data[i].idmatka))) {
               //v i je strc/teta
               for(int n = 0; n < osob; n++)
                  if(!strcmp(data[n].idotec, data[i].id) || !strcmp(data[n].idmatka, data[i].id))
                     PridejOsobu(n, pocet);
            }
         int matka = Index(data[pozice].idmatka);
         if(strlen(data[matka].idotec)) for(int i = 0; i < osob; i++)
            if((strlen(data[matka].idotec) && !strcmp(data[matka].idotec, data[i].idotec)) || (strlen(data[matka].idmatka) && !strcmp(data[matka].idmatka, data[i].idmatka))) {
               //v i je strc/teta
               for(int n = 0; n < osob; n++)
                  if(!strcmp(data[n].idotec, data[i].id) || !strcmp(data[n].idmatka, data[i].id))
                     PridejOsobu(n, pocet);
            }
         }
         break;
      //strc/teta
      case 10:
         int otec = Index(data[pozice].idotec);
         for(int i = 0; i < osob; i++)
            if(!strcmp(data[otec].idotec, data[i].idotec) || !strcmp(data[otec].idmatka, data[i].idmatka))
               PridejOsobu(i, pocet);
         int matka = Index(data[pozice].idmatka);
         for(int i = 0; i < osob; i++)
            if(!strcmp(data[matka].idotec, data[i].idotec) || !strcmp(data[matka].idmatka, data[i].idmatka))
               PridejOsobu(i, pocet);
         break;
   }
   dlgVztahy->Grid1->Repaint();
}

//nacpe osobu na indexu n do dlgVztahy->Grid1
void TForm1::PridejOsobu(int n, int &pocet) {
   for(int i = 0; i < dlgVztahy->Grid1->RowCount; i++)
      if(!strcmp(dlgVztahy->Grid1->Cells[0][i].c_str(), data[n].id)) return;
   pocet++;
   dlgVztahy->Grid1->RowCount = pocet+1;
   dlgVztahy->Grid1->Cells[0][pocet] = data[n].id;
   dlgVztahy->Grid1->Cells[1][pocet] = data[n].jmeno;
   dlgVztahy->Grid1->Cells[2][pocet] = data[n].prijmeni;
   dlgVztahy->Grid1->Cells[3][pocet] = data[n].pohlavi ? "M" : "Z";
   dlgVztahy->Grid1->Cells[4][pocet] = data[n].narozeni ? String(data[n].narozeni) : String("");
   dlgVztahy->Grid1->Cells[5][pocet] = data[n].umrti ? String(data[n].umrti) : String("");
}

//nacpe osobu s id=id do dlgVztahy->Grid1
void TForm1::PridejID(const char *id, int &pocet) {
   for(int i = 0; i < dlgVztahy->Grid1->RowCount; i++)
      if(!strcmp(dlgVztahy->Grid1->Cells[0][i].c_str(), id)) return;
   int n = Index(id);
   if(n != -1) {
      pocet++;
      dlgVztahy->Grid1->RowCount = pocet+1;
      dlgVztahy->Grid1->Cells[0][pocet] = data[n].id;
      dlgVztahy->Grid1->Cells[1][pocet] = data[n].jmeno;
      dlgVztahy->Grid1->Cells[2][pocet] = data[n].prijmeni;
      dlgVztahy->Grid1->Cells[3][pocet] = data[n].pohlavi ? "M" : "Z";
      dlgVztahy->Grid1->Cells[4][pocet] = data[n].narozeni ? String(data[n].narozeni) : String("");
      dlgVztahy->Grid1->Cells[5][pocet] = data[n].umrti ? String(data[n].umrti) : String("");
   }
}

//pevede id na index osoby
int TForm1::Index(const char *id) {
   for(int n = 0; n < osob; n++)
      if(!strcmp(data[n].id, id)) return n;
   return -1;
}

void TForm1::UkazPartnery(int rozdil) {
   dlgVztahy->Grid1->RowCount = 1;

   int pocet = 0;
   for(int i = 0; i < osob; i++) //test na sourozence, potomky a pedky
      if(data[i].pohlavi != data[pozice].pohlavi && abs(data[i].narozeni-data[pozice].narozeni) < rozdil) {
         if(!strcmp(data[i].idotec, data[pozice].id) || !strcmp(data[i].idmatka, data[pozice].id) ||
            !strcmp(data[i].id, data[pozice].idotec) || !strcmp(data[i].id, data[pozice].idmatka) ||
            (strlen(data[i].idotec) && !strcmp(data[i].idotec, data[pozice].idotec)) ||
            (strlen(data[i].idmatka) && !strcmp(data[i].idmatka, data[pozice].idmatka))) continue;
         //test na prarodie a prapotomky
         int otec = Index(data[i].idotec), matka = Index(data[i].idmatka);
         if(otec != -1 && (!strcmp(data[otec].idotec, data[pozice].id) || !strcmp(data[otec].idmatka, data[pozice].id))) continue;
         if(matka != -1 && (!strcmp(data[matka].idotec, data[pozice].id) || !strcmp(data[matka].idmatka, data[pozice].id))) continue;

         otec = Index(data[pozice].idotec); matka = Index(data[pozice].idmatka);
         if(otec != -1 && (!strcmp(data[otec].idotec, data[pozice].id) || !strcmp(data[otec].idmatka, data[pozice].id))) continue;
         if(matka != -1 && (!strcmp(data[matka].idotec, data[pozice].id) || !strcmp(data[matka].idmatka, data[pozice].id))) continue;
         //te ho meme pidat
         PridejOsobu(i, pocet);
      }
   dlgVztahy->Grid1->Repaint();
}
